#include <QApplication>
#include <QMainWindow>
#include <QTreeWidget>
#include <QModelIndex>
#include <QCheckBox>
#include <QToolBar>
#include <QLabel>
#include <QMenu>
#include <QAction>
#include <QMenuBar>
#include <QLabel>
#include <QDebug>

class MyTreeWidget : public QTreeWidget
{
  public:
    QModelIndex indexOfItem(QTreeWidgetItem *itm) const { return indexFromItem(itm); }
};

class MainWindow : public QMainWindow
{
    Q_OBJECT
public:
    explicit MainWindow();

private slots:
    void setRowHidden(bool h);

private:
    MyTreeWidget *m_t;
};

MainWindow::MainWindow() : m_t(new MyTreeWidget)
{
    QMenu *fm = menuBar()->addMenu("File");
    QAction *a = fm->addAction("Visible");
    a->setCheckable(true);
    connect(a, SIGNAL(triggered(bool)), this, SLOT(setRowHidden(bool)));
    addToolBar("TB")->addAction(a);

    setCentralWidget(m_t);
    QTreeWidgetItem *tl = new QTreeWidgetItem(QStringList("TopLevel1"));
    QTreeWidgetItem *itm = new QTreeWidgetItem(tl);
    m_t->setItemWidget(itm, 0, new QLabel("Label set with QTreeWidget::setItemWidget()"));
    m_t->addTopLevelItem(tl);

    m_t->expandAll();
}

void MainWindow::setRowHidden(bool h)
{
    const QModelIndex pI = m_t->indexOfItem(m_t->topLevelItem(0));
    m_t->setRowHidden(0, pI, h);
}

int main(int argc, char *argv[])
{
    QApplication a(argc, argv);
    MainWindow w;
    w.setWindowTitle(QT_VERSION_STR);
    w.move(300, 200);
    w.show();

    return a.exec();
}

#include "main.moc"
